// OctreeBBox.h: interface for the COctreeBBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OCTREEBBOX_H__3A52E53A_40C4_4977_B350_51055FEC9E04__INCLUDED_)
#define AFX_OCTREEBBOX_H__3A52E53A_40C4_4977_B350_51055FEC9E04__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Doublelist.h"
#include "BoundingBox.h"


class COctreeBBox  : public CBoundingBox
{
public:

	COctreeBBox();
	virtual ~COctreeBBox();

	virtual void Draw();

	void Subdivide(unsigned int lvl);
	
	void ClearEmpty(CVector *vertices, int count);
	void ClearEmpty(tBoneVertex *vertices, int count);
	void ClearEmpty(tVERTEX3f *vertices, int count);

	__inline COctreeBBox *GetNode(unsigned int index)
	{
		if(index >=0 && index <=7)
			return m_Node[index];
		else return NULL;
	};

	void Destroy();

private:
	void CheckNodesVisibility();

	unsigned int m_iDivLvl;
	COctreeBBox *m_Node[8];
};



#endif // !defined(AFX_OCTREEBBOX_H__3A52E53A_40C4_4977_B350_51055FEC9E04__INCLUDED_)
